QGIS Application - Feature request #2985
qgis broken with new py-sip
2010-09-06 01:03 PM - jasperla -

Status: Closed

Priority: Low

Assignee: nobody -

Category: Build/Install

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 13045
Description

After updating py-sip to the latest 4.11 release, qgis 1.5.0 doesn't build anymore. It bails out with the following error:

cd /usr/obj/ports/qgis-1.5.0/qgis-1.5.0/python && /usr/local/bin/sip -x [[VendorID]] -t WS_X11 -x [[PyQt]]_NoPrintRangeBug -t
Qt_4_6_3 -x Py_v3 -g -j 4 -c /usr/obj/ports/qgis-1.5.0/qgis-1.5.0/python/core -I /ust/local/share/sip -1
/usr/obj/ports/qgis-1.5.0/qgis-1.5.0/python /usr/obj/ports/qgis-1.5.0/qgis-1.5.0/python/core/core.sip

sip: /usr/obj/ports/qgis-1.5.0/qgis-1.5.0/python/core/conversions.sip:269: Mapped type has already been defined in another
module

*** Error code 1

| can attach the full build log if needed.

History

#1 - 2010-09-07 03:39 AM - sthen -

The following diff fixes things with sip>=4.11; | showed it to Phil
Banks who thinks it's ok as a workaround and suggests it is made
conditional depending on the version of SIP that is found.

--- python/core/conversions.sip.orig Tue Sep 7 00:14:55 2010
+++ python/core/conversions.sip Tue Sep 7 00:17:23 2010
@@ -265,59 +265,6 @@ template <TYPE>

-%MappedType QSet<int>

|

-%TypeHeaderCode

-#include <QSet>

-#if (SIP_VERSION >= 0x040900)

-#define sipClass_QString ((sipWrapperType *) sipTypeAsPyTypeObiject (sipType_QString))
-#define sipClass_QVariant ((sipWrapperType *) sipTypeAsPyTypeObject (sipType_QVariant))
-#endif

-%End

-%ConvertFromTypeCode

- // Create the list.

- [[PyObject]] *I;

- if (I = [[PyList]]_New(sipCpp->size())) == NULL)

- return NULL;
- // Set the list elements.

- QSet<int>:iterator it = sipCpp->begin();

- for (inti = 0; it |= sipCpp->end(); ++it, ++i)
-{

- [[PyObject]] *tobj;

- if ((tobj = [[PyInt]]_FromLong(*it)) == NULL)
-

- Py_DECREF(l);

- return NULL;

-}

- [[PyList]]_SET_ITEM(l, i, tobj);

-1

- return [

-%End

-%ConvertToTypeCode

- /I Check the type if that is all that is required.
- if (siplsErr == NULL)

- return [[PyList]]_Check(sipPy);

- QSet<int> *gset = new QSet<int>;

- for (inti = 0;i < [[PyList]]_GET_SIZE(sipPy); ++i)

-{

- gset->insert(PyInt_AsLong(PyList_GET_ITEM(sipPy, i)));
-1

- *sipCppPtr = gset;

- return sipGetState(sip TransferObj);
-%End

¥

template <TYPE>
%MappedType QSet<TYPE>

{

#2 - 2010-09-11 04:04 PM - Volker Fréhlich

Doesn't work for me with QGIS 1.5, SIP 4.11 and Qt 4.7:
[ 95%] Generating ui_qgsplugininstallerbase.py
cd /builddir/build/BUILD/qgis-1.5.0/python/plugins/plugin_installer && /usr/bin/pyuic4 /builddir/build/BUILD/qgi
s-1.5.0/python/plugins/plugin_installer/qgsplugininstallerbase.ui -o /builddir/build/BUILD/qgis-1.5.0/python/plu
gins/plugin_installer/ui_qgsplugininstallerbase.py
An unexpected error occurred.
Check that you are using the latest version of [[PyQt]] and send an error report to
support@riverbankcomputing.com, including the following information:

- your version of [[PyQt]] (4.7.6)

2024-03-13 2/4


mailto:support@riverbankcomputing.com

- the Ul file that caused this error

- the debug output of pyuic4 (use the -d flag when calling pyuic4)
maker2: Leaving directory /builddir/build/BUILD/qgis-1.5.0'
maker1: Leaving directory /builddir/build/BUILD/qgis-1.5.0'
maker2: * [python/plugins/plugin_installer/ui_qgsplugininstallerbase.py] Error 1
maker1: [python/plugins/plugin_installer/CMakeFiles/pluginstaller.dir/all] Error 2
make: ** [all] Error 2

#3 - 2010-09-12 02:19 AM - sthen -

Ah sorry | forgot to mention that one; it is a regression with pyuic 4.7.6 on python 2.x - please use a development snapshot of py-qt4 instead or remove

"encoding='utf8" from pyuic/uic/driver.py around line 60.

#4 - 2010-09-21 09:15 AM - John Tull

Using [[PyQt]]-4.7.7, released today, along with sip-4.11, | still get the originally posted error. The above patch worked for me. Should this be applied to

trunk?

#5 - 2010-10-03 06:57 AM - Jiirgen Fischer
- Resolution set to fixed
- Status changed from Open to Closed

#6 - 2010-11-17 08:25 AM - Attila Olah -
- Status changed from Closed to Feedback
- Resolution deleted (fixed)

I'm reopening this because changeset 14325 introduced a Developer Warning that has still not been fixed. Please change
"trunk/qgis/python/CMakelLists.txt" line 44 to match the opening IF statement arguments (on line 42).

#7 - 2010-11-17 08:32 AM - Jiirgen Fischer
- Resolution set to fixed
- Status changed from Feedback to Closed

was already fixed in commit:8ffd8165 (SVN r14331) (see https://trac.osgeo.org/qgis/browser/trunk/qgis/python/CMakeLists.txt#L42).

#8 - 2010-11-17 08:46 AM - Attila Olah -

Ouch. Now how the hell did | miss that.

In that case, sorry for making noise here; and thanks very much for your work, jef. I've merged the diffs from commit:3cf96c28 (SVN r14324),
commit:926fc951 (SVN r14325), commit:82edec5a (SVN r14326) and commit:8ffd8165 (SVN r14331) into a patch to backport this fix to version 1.5.0 in
Gentoo, it works pretty well.
